(**************************************************************************)
(*                                                                        *)
(* Proof of the Heapsort Algorithm.                                       *)
(*                                                                        *)
(* Jean-Christophe Fillitre (LRI, Universit Paris Sud)                  *)
(* March 1999                                                             *)
(*                                                                        *)
(**************************************************************************)

Require Programs.
Require Exchange.

Correctness swap
  fun (N:Z)(t:array N of Z)(i,j:Z) ->
    { `0 <= i < N` /\ `0 <= j < N` }
    (let v = t[i] in
     begin
       t[i] := t[j];
       t[j] := v
     end)
    { (exchange t t@ i j) }.
Proof.
Auto with datatypes.
Save.
