
(* Heapsort *)

let swap t i j =
  let tmp = t.(i) in begin t.(i) <- t.(j); t.(j) <- tmp end

(* downheap t k n : rtablit un tas enracin en k et d'indices <= n
 * en supposant que seule la racine n'est pas bien place *)
let rec downheap t k n =
  let j = k+k+1 in
  if j <= n then
    let j' = if j+1 <= n then if t.(j) < t.(j+1) then j+1 else j else j in
    if t.(k) < t.(j') then begin swap t k j'; downheap t j' n end

(* heapsort t n : trie les n premiers lments du tableau t *)
let heapsort t n =
  for k = (n-2) / 2 downto 0 do downheap t k (n-1) done;
  for k = n-1 downto 1 do 
    swap t 0 k;
    downheap t 0 (k-1)
  done
    
(* test : teste un programme de tri *)

let est_tri t =
  let ok = ref true in
  for i = 0 to Array.length t - 2 do
    ok := !ok & t.(i) <= t.(i+1)
  done;
  !ok

let test maxs maxn =
  for i = 1 to 10000 do
    let n = Random.int maxs in
    let t = Array.init n (fun _ -> Random.int maxn) in
    heapsort t n;
    if not (est_tri t) then Printf.printf "ARGHH\n"; flush stdout;
  done;
  Printf.printf "OK\n"; flush stdout
